import junit.framework.Assert;
import junit.framework.TestCase;
/**
 * 
 */

/**
 * @author Alan Williams
 *
 */
public class ProductTest extends TestCase
{

	/**
	 * Test method for 'Product.getName()'.
	 */
	public void testGetName( )
	{
		String nameTestData = "product 1";
		double costTestData = 12.34;
		int pointsTestData = 5678;
		
		Product p = new Product( nameTestData, costTestData, pointsTestData );
		
		String expectedName = new String( nameTestData );
		String actualName = p.getName();
		Assert.assertEquals( expectedName, actualName );
	}

	/**
	 * Test method for 'Product.getCost()'.
	 */
	public void testGetCost( )
	{
		String nameTestData = "product 2";
		double costTestData = 91.02;
		int pointsTestData = 3456;
		
		Product p = new Product( nameTestData, costTestData, pointsTestData );
		
		double expectedCost = costTestData;
		double actualCost = p.getCost();
		Assert.assertEquals( expectedCost, actualCost, 0.001 );
	}

	/**
	 * Test method for 'Product.getPointsRequired()'.
	 */
	public void testGetPointsRequired( )
	{
		String nameTestData = "product 3";
		double costTestData = 43.57;
		int pointsTestData = 6899;
		
		Product p = new Product( nameTestData, costTestData, pointsTestData );
		
		int expectedPoints = pointsTestData;
		int actualPoints = p.getPointsRequired();
		Assert.assertEquals(expectedPoints, actualPoints);
	}

}
